(function(){
	var getParameterByName = function(name, query) {  
	    var match = RegExp('[?&]' + name + '=([^&]*)').exec(query);  
	    return match && decodeURIComponent(match[1].replace(/\+/g, ' '));  
	}
	var getUnixTime = function(){
		var result=Math.round(Date.parse(new Date())/1000);
		return result;
	}
	var mp = function(user, pwd){
		this.user = user;
		this.pwd = pwd;
	};
	var reg = {
		publicToken: /pluginToken : '([^']+)'/i,
		appId: /appid : '([^']+)'/i
	};
	var headers = { "referer": "https://mp.weixin.qq.com/" };
	var mppro = mp.prototype = {
		session: {
			token: '',	//登录成功后的token
			publicToken: '',
			appId: ''
		},
		/**
		 * 模拟登录
		 * */
		login: function(fnSucceed,fnFail){			
			api.ajax({
			    url: 'https://mp.weixin.qq.com/cgi-bin/login?lang=zh_CN',
			    method: 'post',
			    timeout: 30,
			    dataType: 'json',
			    returnAll:false,
			    headers: headers,
			    data: { values: { "username": this.user, "pwd": this.pwd, "f": 'json'}}
			},function(ret,err){
			    if(ret.base_resp.ret!=0)
			    {
			        fnFail(ret.base_resp.ret);
			        return;
			    }		    
			    mppro.session.token = getParameterByName('token', ret.redirect_url);
			    //获取对应的appid及publicToken
			    var tokenUrl = 'https://mp.weixin.qq.com/misc/pluginloginpage?action=stat_user_summary&pluginid=luopan&t=statistics/index&token=' + mppro.session.token + '&lang=zh_CN';
			    api.ajax({
				    url: tokenUrl,
				    method: 'get',
				    timeout: 30,
				    dataType: 'text',
				    returnAll:false,
				    headers: headers
				},function(ret,err){
					mppro.session.appId = ret.match(reg.appId)[1];
					mppro.session.publicToken = ret.match(reg.publicToken)[1];
					if (fnSucceed) {
						$api.setStorage('XiGua_MPSession', mppro.session);
						fnSucceed.call(mppro);
					}
				});
			});
		},
		userLogin:function(imgCode,fnSucceed,fnFail)
		{
		   api.ajax({
			    url: 'https://mp.weixin.qq.com/cgi-bin/login?lang=zh_CN',
			    method: 'post',
			    timeout: 30,
			    dataType: 'json',
			    returnAll:false,
			    headers: headers,
			    data: { values: { "username": this.user, "pwd": md5.hex(this.pwd), "f": 'json',"imgcode":imgCode}}
			},function(ret,err){ 
			   try
			   {
			    if(ret.base_resp.ret!=0||ret.redirect_url.indexOf('acct/ban')!=-1)
			    {
			        fnFail(ret.base_resp.ret);
			    }
			    else
			    {
			        fnSucceed(ret.redirect_url);
			    }
			   }
			   catch(e)
			   {
			     XiGua.log(e);
			   }
                
			});
		},
		getBizInfo : function(redir,fnNickName) {
			var baseInfoUrl = 'https://mp.weixin.qq.com' + redir;
			api.ajax({
				url : baseInfoUrl,
				method : 'get',
				timeout : 30,
				dataType : 'text',
				returnAll : false,
				headers : headers
			}, function(result) {
			    fnNickName(result.match(/nick_name:"([^"]+)",/)[1]);
			});
		},
		/**
		 * 从缓存中载入MPSession
		 * */
		loadSessionFromCache: function(){
			mppro.session = $api.getStorage('XiGua_MPSession');
		},
		/**
		 * 获取昨日关键用户统计数据 
		 * */
		getUserSummary: function(fnSucceed){
			var endDate = new Date((new Date()).setDate(new Date().getDate() - 1)); 
			var startDate = new Date((new Date()).setDate(endDate.getDate() - 30)); 
			var url = 'https://mta.qq.com/mta/wechat/ctr_user_summary/get_key_index_data_and_chart?start_date=' 
				+ startDate.format('yyyy-MM-dd') + '&end_date='
				+ endDate.format('yyyy-MM-dd') + '&need_compare=0&start_compare_date=&end_compare_date=&app_id=&appid=' 
				+ mppro.session.appId + '&pluginid=luopan&token=' 
				+ mppro.session.publicToken + '&from=&src=false&devtype=2&time_type=day&rnd=' 
				+ getUnixTime() + '&ajax=1';
			api.ajax({
			    url: url,
			    method: 'get',
			    timeout: 30,
			    dataType: 'json',
			    returnAll:false,
			    headers: headers
			},function(ret,err){
				if (fnSucceed) {
					fnSucceed.call(mppro, ret);
				}
			});
		},
		/**
		 * 获取昨日关键图文统计数据 
		 * */
		getArticleSummary: function(fnSucceed){
			var endDate = new Date((new Date()).setDate(new Date().getDate() - 1)); 
			var startDate = new Date((new Date()).setDate(endDate.getDate() - 30)); 
			var url = 'https://mta.qq.com/mta/wechat/ctr_article_analyse/get_key_index_data_and_chart?start_date=' 
				+ startDate.format('yyyy-MM-dd') + '&end_date='
				+ endDate.format('yyyy-MM-dd') + '&need_compare=0&start_compare_date=&end_compare_date=&app_id=&appid=' 
				+ mppro.session.appId + '&token=' 
				+ mppro.session.publicToken + '&from=&src=false&devtype=2&time_type=day&rnd=' 
				+ getUnixTime() + '&ajax=1';
			api.ajax({
			    url: url,
			    method: 'get',
			    timeout: 30,
			    dataType: 'json',
			    returnAll:false,
			    headers: headers
			},function(ret,err){
				if (fnSucceed) {
					fnSucceed.call(mppro, ret);
				}
			});
		},
		/**
		 * 获取图文详情数据 
		 * */
		getArticleDetail: function(page, fnSucceed){
			var endDate = new Date((new Date()).setDate(new Date().getDate() - 1)); 
			var startDate = new Date((new Date()).setDate(endDate.getDate() - 30)); 
			var url = 'https://mta.qq.com/mta/wechat/ctr_article_detail/get_list?sort=RefDate%20desc&keyword=&page='
			+ page + '&appid='
			+ mppro.session.appId 
			+ '&pluginid=luopan&token='
			+ mppro.session.publicToken
			+'&from=&src=false&devtype=2&time_type=day&start_date='
			+ startDate.format('yyyy-MM-dd')
			'&end_date=' 
			+ endDate.format('yyyy-MM-dd')
			+ '&need_compare=0&app_id=&rnd='
			+ getUnixTime()
			+ '&ajax=1';
			api.ajax({
			    url: url,
			    method: 'get',
			    timeout: 30,
			    dataType: 'json',
			    returnAll:false,
			    headers: headers
			},function(ret,err){
				if (fnSucceed) {
					fnSucceed.call(mppro, ret);
				}
			});
		}
	};
	window.WechatMP = mp;
})();