(function() {
	var articleOperator = {
		bindArtilceListEvent : function($html, url) {
			//详情点击
			$html.find('section>div.articleListCover,section>div.articleListMain,section>div.mpDetailHistoryMain').click(function() {
				var $section = $(this).parents('section');
				api.openWin({
					name : 'articleDetail',
					url : url || 'detail.html',
					bounces : false,
					pageParam : {
						title : $section.find('a.detailUrl').text(),
						contentName : 'detail',
						contentUrl : $section.attr('data-href'),
						articleId : $section.attr('data-articleId'),
						read : $section.attr('data-read') * 1,
						like : $section.attr('data-like') * 1,
						score : $section.attr('data-score') * 1
					}
				});
			});
			//收藏点击
			$html.find('a.btnFavorite').click(function() {
				var $this = $(this);
				var $section = $this.parents('section');
				var articleId = $section.attr('data-articleId');
				var actionUrl = 'MArticle/AddCollect/';
				var faved = $this.hasClass('btnArtFavorited');
				if (faved) {
					actionUrl = 'MArticle/RemoveCollect/';
				}
				$.getJSON(XiGua.buildUrl(actionUrl, 'articleId=' + articleId), function(result) {
					if (result.Status) {
						if (faved == false) {
							api.toast({
								msg : '文章添加到素材库成功',
								duration : 1000,
								location : 'bottom'
							});
							$this.addClass('btnArtFavorited');
						} else {
							api.toast({
								msg : '取消收藏成功',
								duration : 1000,
								location : 'bottom'
							});
							$this.removeClass('btnArtFavorited');
						}
					} else {
						api.toast({
							msg : '操作失败',
							duration : 2000,
							location : 'bottom'
						});
					}
				});
			});
		}
	}
	window.XiGua = {
		sessionId : '',
		apiUrl : 'http://114.215.196.241/',
		currentBiz : null,
		_readyFn : null,
		/**
		 * Api载入完成后激发
		 * */
		ready : function(fn, webDebug) {

			this._readyFn = fn;
			if (webDebug)
				fn();
		},
		/**
		 * 保存当前设置
		 */
		save : function() {
			$api.setStorage('XiGua_UserSession', {
				sessionId : this.sessionId,
				currentBiz : this.currentBiz
			});
		},
		reloadSession : function() {
			var userSession = $api.getStorage('XiGua_UserSession') || {
				sessionId : '',
				currentBiz : null,
				currentBizId : 0
			};
			XiGua.sessionId = userSession.sessionId;
			XiGua.currentBiz = userSession.currentBiz;
			//	XiGua.currentBizId=userSession.currentBizId;
		},
		log : function(msg) {
			var postData = {
				"bizId" : XiGua.getBiz()!=null?XiGua.getBiz().BizId:0,
				"source":JSON.stringify(msg),
				"logDetail" : msg.message 
			};
			var option = {
				type : 'POST',
				data : JSON.stringify(postData),
				url : XiGua.buildUrl('Service/AddExceptionLog/'),
				dataType : "json",
				contentType : "application/json;charset=utf-8",
				success : function(result) {
				}
			};
			$.ajax(option);
		},
		/**
		 * 获取当前选择的公众号
		 * */
		getBiz : function() {
			if (this.currentBiz == null) {
				this.reloadSession();
			}
			return this.currentBiz;
		},
		/**
		 * 构建请求的Url，附上SessionId
		 * */
		buildUrl : function(path, query) {
			if (path.length > 0 && path[path.length - 1] != '/') {
				path += '/';
			}
			if ( typeof query != 'undefined' && query) {
				query = '&' + query;
			} else {
				query = '';
			}
			if (this.sessionId == '') {
				this.reloadSession();
			}
			return this.apiUrl + path + '?sessionId=' + this.sessionId + query;
		},
		/**
		 * 用户默认配置
		 * */
		getUserSettings : function() {
			var defaultSettings = {
			};
			return $api.getStorage('XiGua_UserSettings') || defaultSettings;
		},
		/**
		 * 保存用户设置
		 * */
		saveUserSettings : function(settings) {
			$api.setStorage('XiGua_UserSettings', settings);
		},
		/**
		 * 重新加载用户配置
		 * */
		reloadUserSettings : function(callback) {
			var settings = this.getUserSettings();
			var url = XiGua.buildUrl('Service/GetUserSettings');
			$.getJSON(url, function(result) {
				settings = result;
				$api.setStorage('XiGua_UserSettings', settings);
				if (callback) {
					callback(settings);
				}
			});
		},
		/**
		 * html渲染
		 * */
		renderHtml : function(template, data) {
			return template.replace(/\{([\w\.]*)\}/g, function(str, key) {
				var keys = key.split("."), v = data[keys.shift()];
				for (var i = 0, l = keys.length; i < l; i++)
					v = v[keys[i]];
				return ( typeof v !== "undefined" && v !== null) ? v : "";
			});
		},
		showLoading : function() {
			api.showProgress({
				style : 'default',
				animationType : 'fade',
				title : '努力加载中...',
				text : '马上就好啦',
				modal : false
			});
		},
		hideLoading : function() {
			api.hideProgress();
		},
		/**
		 * 于素材相关的通用逻辑代码
		 * */
		article : articleOperator
	};
	window.apiready = function() {
		//获取SessionId
		XiGua.reloadSession();
		XiGua._readyFn && XiGua._readyFn();
	};

	Date.prototype.format = function(fmt) {
		var o = {
			"M+" : this.getMonth() + 1, //月份
			"d+" : this.getDate(), //日
			"h+" : this.getHours(), //小时
			"m+" : this.getMinutes(), //分
			"s+" : this.getSeconds(), //秒
			"q+" : Math.floor((this.getMonth() + 3) / 3), //季度
			"S" : this.getMilliseconds() //毫秒
		};
		if (/(y+)/.test(fmt))
			fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
		for (var k in o)
		if (new RegExp("(" + k + ")").test(fmt))
			fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
		return fmt;
	};
})();
